#!/bin/sh

echo "BIXOLON CO Ltd"
echo "BIXOLON SLP-DX420_Receipt CUPS DRIVER V1.0.0 Installer"
echo "---------------------------------------"
echo ""
echo ""

ROOT_UID=0

if [ "$UID" -ne "$ROOT_UID" ]
then
    echo "This script requires root user access..."
    echo "Re-run as root user..."
    exit 1
fi

echo "Copying rastertoBxlLabelReceipt_v1.0.0 filter..."

LINUX_CHECK="$(cat /etc/*-release | grep -ic gentoo)"
SUSE_CHECK="$(cat /etc/*-release | grep -ic SUSE)"
NO_GENTOO=0
NO_SUSE=0

if [ ${LINUX_CHECK} = ${NO_GENTOO} ]
then
	if [ ${SUSE_CHECK} = ${NO_SUSE} ]
	then
		LIBPATH="lib"
	else
		LIBPATH="lib64"
	fi
else
	LIBPATH="libexec"
fi


 sudo chmod +x rastertoBxlLabelReceipt_v1.0.0
 sudo cp ./rastertoBxlLabelReceipt_v1.0.0 /usr/bin/
 sudo chmod 0755 /usr/bin/rastertoBxlLabelReceipt_v1.0.0
echo ""

echo "Creating Symbolic Link...."
  sudo ln -s /usr/bin/rastertoBxlLabelReceipt_v1.0.0 /usr/${LIBPATH}/cups/filter/rastertoBxlLabelReceipt
  sudo chmod 0755 /usr/${LIBPATH}/cups/filter/rastertoBxlLabelReceipt

### CUPS VERSION 1.7.2 Has Broken USB backend
CUPSVER="$(cups-config --version)"
echo "CUPS VERSION: ${CUPSVER}"
CKVER=1.7.2

if [ ${CUPSVER} = ${CKVER} ] ;
then
	echo "Copy usb backend...."
	sudo cp ./usb /usr/${LIBPATH}/cups/backend/;
	sudo chmod 0755 /usr/${LIBPATH}/cups/backend/usb;
	cp ./usb /usr/${LIBPATH}/cups/backend-available/;
	sudo chmod 0755 /usr/${LIBPATH}/cups/backend-available/usb;
fi;

echo ""


if [ -x /etc/init.d/cupsys ]
then
	if [ -r /etc/debian_version ]
	then
		if [ -r /etc/lsb-release ]
		then
			 sudo cp -r ./SLPDX420Receipt_v1.0.0.ppd /usr/share/cups/model/
			 sudo chmod 0755 /usr/share/cups/model/SLPDX420Receipt_v1.0.0.ppd
		else
			 sudo cp ./SLPDX420Receipt_v1.0.0.ppd /usr/share/ppd/ 
			 sudo chmod 0755 /usr/share/ppd/SLPDX420Receipt_v1.0.0.ppd
		fi
	else
		 sudo cp -r ./SLPDX420Receipt_v1.0.0.ppd /usr/share/cups/model/
		 sudo chmod 0755 /usr/share/cups/model/SLPDX420Receipt_v1.0.0.ppd
	fi
else
	if [ -r /etc/debian_version ]
	then
		 sudo cp -r ./SLPDX420Receipt_v1.0.0.ppd /usr/share/cups/model/
		 sudo chmod 0755 /usr/share/cups/model/SLPDX420Receipt_v1.0.0.ppd
	else
		 sudo cp -r ./SLPDX420Receipt_v1.0.0.ppd /usr/share/cups/model/
		 sudo chmod 0755 /usr/share/cups/model/SLPDX420Receipt_v1.0.0.ppd
	fi
fi 
echo ""

echo "Restarting CUPS"
    if [ -x /etc/software/init.d/cups ]
    then
        sudo /etc/software/init.d/cups stop
        sudo /etc/software/init.d/cups start
    elif [ -x /etc/rc.d/init.d/cups ]
    then
        sudo /etc/rc.d/init.d/cups stop
        sudo /etc/rc.d/init.d/cups start
    elif [ -x /etc/init.d/cups ]
    then
        sudo /etc/init.d/cups stop
        sudo /etc/init.d/cups start
    elif [ -x /sbin/init.d/cups ]
    then
        sudo /sbin/init.d/cups stop
        sudo /sbin/init.d/cups start
    elif [ -x /etc/software/init.d/cupsys ]
    then
        sudo /etc/software/init.d/cupsys stop
        sudo /etc/software/init.d/cupsys start
    elif [ -x /etc/rc.d/init.d/cupsys ]
    then
        sudo /etc/rc.d/init.d/cupsys stop
        sudo /etc/rc.d/init.d/cupsys start
    elif [ -x /etc/init.d/cupsys ]
    then
        sudo /etc/init.d/cupsys stop
        sudo /etc/init.d/cupsys start
    elif [ -x /sbin/init.d/cupsys ]
    then
        sudo /sbin/init.d/cupsys stop
        sudo /sbin/init.d/cupsys start
    else
        echo "Could not restart CUPS"
    fi

	if [ ${LINUX_CHECK} = ${NO_GENTOO} ]
	then
    	sudo service cups stop
    	sudo service cups start
	else
		sudo service cupsd stop
		sudo service cupsd start
	fi

    echo ""


echo "Install Complete"
echo "Add printer queue using OS tool, http://localhost:631, or http://127.0.0.1:631"
echo ""

